Program TestWin;
{ This program shows how to use objects from the
  unit WINDOWS. It opens three windows (two with
  single border, one with double border) and performs
  typical operations like writing text in windows
  and clearing windows. Start the operations by
  pressing Enter. Note the changing amount of free RAM. }

Uses Windows,Graph;

Var   w1,w2:PWindowP;
      w3   :DWindowP;
  grDriver : Integer;
  grMode   : Integer;
  ErrCode  : Integer;

Procedure DispMem;
var S:string;
begin
   SetColor(White);
   Str(MemAvail:9,S);
   SetTextJustify(CenterText,CenterText);
   OutTextXY(400,30,'Free memory: ' + S);
end;

Procedure ClearMem;
begin
   SetFillStyle(SolidFill,Black);
   Bar(250,10,550,40);
end;

Begin
  grDriver := Detect;
  InitGraph(grDriver,grMode,'c:\tp\bgi');
  ErrCode := GraphResult;
  if ErrCode = grOk then begin
      DispMem;Readln;ClearMem;
      New(w1);
      With w1^ do begin
        WOpen(100,100,300,200,Blue,DarkGray,LightBlue,Yellow);
        Wrt (3,1,'This is');
        WrtE(3,3,'WINDOW 1');
        DispMem;Readln;
        WClear;
        Wrt (1,1,'Another text');
        WrtE(5,5,'IN WINDOW 1');
        Readln;ClearMem;
        New(w2);
        With w2^ do begin
          WOpen(140,130,440,330,Red,Blue,LightRed,Yellow);
          Wrt (4,1,'This is');
          WrtE(4,3,'WINDOW 2');
          DispMem;Readln;ClearMem;
          New(w3);
          With w3^ do begin
            WOpen(180,160,380,240,Yellow,DarkGray,Green,Yellow);
            Wrt (5,2,'This is');
            WrtE(5,4,'WINDOW 3');
            DispMem;Readln;ClearMem;
            WClose;
          end{with};
          Dispose(w3);
          DispMem;Readln;ClearMem;
          WClose;
        end{with};
        Dispose(w2);
        DispMem;Readln;ClearMem;
        WClose;
      end{with};
      Dispose(w1);
      OutTextXY(GetMaxX div 2, GetMaxY div 2, 'The end');
      DispMem;ReadLn;ClearMem;
      CloseGraph;
    end
  else begin
    WriteLn('Graphics error: ', GraphErrorMsg(ErrCode));
    Readln;
  end{if};
end.
